<?
	
	require_once ("config.php");
	require_once ("lib/template.class.php");
	require_once ("lib/session.class.php");
	require_once ("lib/db_mysql.class.php");
	require_once ("lib/string.lib.php");
	
	// check session
	$sess = init_session() or show_error(7001, "Cannot init. session!", $HTTP_SERVER_VARS, true);
	if ($sess->name == "") show_error(8000, $RES["0085"], $HTTP_SERVER_VARS, true);	// permission denied
	
	// create template object
	$tpl = new Template(".");
	
	// declare template files
	$tpl->set_file(array(
		"adress" 		=> "tpl_adress.html",
		"adress_detail"=> "tpl_adress_detail.html",
		"adress_edit"	=> "tpl_adress_edit.html",
		"content" 		=> "tpl_content.html",
		"message" 		=> "tpl_message.html"
	));
	
	// set language fields
	$aTpl = array("adress", "adress_detail", "adress_edit", "content");	// templates to parse
	while (list($kTpl,$vTpl) = each ($aTpl))
	{
		$arr_undef = $tpl->get_undefined($vTpl);
		while (list($k, $v) = each ($arr_undef))
		{	$tpl->set_var($k,$RES[$v]); }
	}
	
	//-------------------------------------------------------------------------
	// 
	//-------------------------------------------------------------------------
	switch ($action)
	{
		case "update":
		{
			// permission check		
			if($sess->data["priv_sysadmin"] != 1)	show_error(8000, $RES["0085"], $HTTP_SERVER_VARS, true);	// permission denied
				
			$IMG_ARROW	= "<img src='img/arrow_red.gif' width='11' height='11'>";
			$sError = "";
			
			// check input
			$ugid = $sess->data["user_group_id"];
			
			if(!isset($ugid) || $ugid < 1)
				$sError .= $IMG_ARROW." ".$RES["0089"]."<br>";	// user group is missing
			
			// email
			$email = trim($email);
			if(is_email($email) == false && $email != "")
				$sError .= $IMG_ARROW." ".$RES["0057"]."<br><br>";	
			
			// are there any errors ?
			if($sError == "")	
			{
				$db = new Database();
				if (!$db->connect()) show_error($db->errno, $db->error, $HTTP_SERVER_VARS, true);
				
				if($chk_login 		!= 1) 	$chk_login 		= 0;
				if($chk_groupadmin!= 1) 	$chk_groupadmin= 0;
				if($chk_sysadmin 	!= 1) 	$chk_sysadmin 	= 0;
			
				// generate query
				$query = sprintf("UPDATE user SET firstname='%s', lastname='%s', street='%s', zip='%s', city='%s', telephone='%s', fax='%s', mobile='%s', email='%s', url='%s', comment='%s', priv_login=%s, priv_groupadmin=%s, priv_sysadmin=%s WHERE user_id=%s AND user_group_id=%s", $firstname, $lastname, $street, $zip, $city, $telephone, $fax , $mobile, $email, $url, $comment, $chk_login, $chk_groupadmin, $chk_sysadmin, $user_id, $sess->data["user_group_id"]);
				#echo $query; exit;
				
				if (!$db->query($query))		show_error($db->errno, $db->error, $HTTP_SERVER_VARS, true);			
				
				$tpl->set_var(array(
					"MSG_TITLE" 	=> $RES["0091"],	// ok
					"MSG_TEXT" 		=>	$RES["0133"],	// changes has been updated successfully
					"BTN1_CLICK" 	=> $RES["0072"],	// window.close()
					"MSG_BUTTON_1" => $RES["0061"]	// refresh parent child
				));
							
				// print template 
				$tpl->pparse("OUT", "message");
				exit;
			}
			else
			{
				// print error messages
				$tpl->set_var(array(
					"MSG_TITLE" 	=> $RES["0093"],	// error
					"MSG_TEXT" 		=>	$sError,			// error message/s
					"BTN1_CLICK" 	=> $RES["0070"],	// history.back()
					"MSG_BUTTON_1" => $RES["0055"]	// back
				));
					
				$tpl->pparse("OUT", "message");
				exit;
			}
			
			break;		
		
		}
		
		case "edit":
		{
			// permission check
			if($sess->data["priv_sysadmin"] != 1)	show_error(8000, $RES["0085"], $HTTP_SERVER_VARS, true);	// permission denied
					
			// get entry
			$db = new Database();
			if (!$db->connect()) show_error($db->errno, $db->error, $HTTP_SERVER_VARS, true);

			$query = sprintf("SELECT * FROM user WHERE user_id = %s AND user_group_id = %s", $id, $sess->data["user_group_id"]);		
			#echo $query, exit;

			if (!$db->query($query))	show_error($db->errno, $db->error, $HTTP_SERVER_VARS, true);			
			if($db->num_rows() < 1)		show_error(8000, $RES["0085"], $HTTP_SERVER_VARS, true);	// permission denied

			// set fields
			$db->next_record();
			
			if($db->field("priv_login") 		== 1) $chk_login 		= "checked";
			if($db->field("priv_groupadmin")	== 1) $chk_groupadmin= "checked";
			if($db->field("priv_sysadmin") 	== 1) $chk_sysadmin 	= "checked";
				
			$tpl->set_var(array(
				"USER_ID"	=> $db->field("user_id"),
				"FIRSTNAME"	=> $db->field("firstname"),
				"LASTNAME" 	=> $db->field("lastname"),
				"STREET" 	=> $db->field("street"),
				"ZIP" 		=> $db->field("zip"),
				"CITY" 		=> $db->field("city"),
				"TELEPHONE"	=> $db->field("telephone"),
				"MOBILE"		=> $db->field("mobile"),
				"FAX" 		=> $db->field("fax"),
				"EMAIL" 		=> $db->field("email"),
				"URL" 		=> $db->field("url"),
				"COMMENT" 	=> $db->field("comment"),
				"PRIV_LOGIN" 		=> $chk_login,
				"PRIV_GROUPADMIN" => $chk_groupadmin,
				"PRIV_SYSADMIN" 	=> $chk_sysadmin
			));
		
			// parse and print the template
			$tpl->pparse("OUT", "adress_edit");
			break;
			
		}

		case "detail":
		{
			
			// get entry
			$db = new Database();
			if (!$db->connect()) show_error($db->errno, $db->error, $HTTP_SERVER_VARS, true);
			
			$query = sprintf("SELECT * FROM user WHERE user_id = %s AND user_group_id = %s", $id, $sess->data["user_group_id"]);		
			#echo $query, exit;

			if (!$db->query($query))	show_error($db->errno, $db->error, $HTTP_SERVER_VARS, true);			
			if($db->num_rows() < 1)		show_error(8000, $RES["0085"], $HTTP_SERVER_VARS, true);	// permission denied

			// set fields
			$db->next_record();

			$tpl->set_var(array(
				"FIRSTNAME"	=> $db->field("firstname"),
				"LASTNAME" 	=> $db->field("lastname"),
				"STREET" 	=> $db->field("street"),
				"ZIP" 		=> $db->field("zip"),
				"CITY" 		=> $db->field("city"),
				"TELEPHONE"	=> $db->field("telephone"),
				"MOBILE"		=> $db->field("mobile"),
				"FAX" 		=> $db->field("fax"),
				"EMAIL" 		=> $db->field("email"),
				"URL" 		=> $db->field("url"),
				"COMMENT" 	=> $db->field("comment"),
			));
		
			// parse and print the template
			$tpl->pparse("OUT", "adress_detail");
			break;
		}
				
		case "delete":
		{
			// check permission
			if($sess->data["priv_sysadmin"] != 1)	show_error(8000, $RES["0085"], $HTTP_SERVER_VARS, true);	// permission denied

			// delete entry
			$db = new Database();
			if (!$db->connect()) show_error($db->errno, $db->error, $HTTP_SERVER_VARS, true);

			$query = sprintf("DELETE FROM user WHERE user_id = %s AND user_group_id = %s", $uid, $sess->data["user_group_id"]);		
			if (!$db->query($query))	show_error($db->errno, $db->error, $HTTP_SERVER_VARS, true);			

			// no break, goto default:
		}
		default:
		{
			
			// permission check
			if($sess->data["priv_sysadmin"] == 1)
				$sEdit = "<a href=\"javascript:window_open('adress.php?action=edit&id={ID}', 390,350)\"><img src='img/edit.gif' width='16' heigh='16' border='0' alt='" . $RES["0029"]  . "'></a><a href='javascript:confirm_del({ID})'><img src='img/delete.gif' alt='" . $RES["0030"]  . "' width='15' height='15' border='0'></a><b>";
				//$sEdit = "<a href=\"javascript:alert('Diese Funktion steht noch nicht zur Verfgung!')\"><img src='img/edit.gif' width='16' heigh='16' border='0' alt='" . $RES["0029"]  . "'></a><a href='javascript:confirm_del({ID})'><img src='img/delete.gif' alt='" . $RES["0030"]  . "' width='15' height='15' border='0'></a><b>";
			
			// table background colors
			$BGRD_CLR_1 = "#FFFF99";	// yellow
			$BGRD_CLR_2 = "#FFFFCC";	// dark yellow
			$BGRD_CLR_3 = "#FFC4C4";	// red (for today)
		
			$db = new Database();
			if (!$db->connect())		show_error($db->errno,  $db->error, $HTTP_SERVER_VARS, true); // database connection failed

			if (isset($c))			$query_ext = sprintf(" AND LCASE(lastname) LIKE '%s' ", "$c%");
			if (isset($search)) 	$query_ext = sprintf(" AND (LCASE(lastname) LIKE '%s' OR firstname LIKE '%s') ", "%$search%", "%$search%");

			// select only members with priv_login = 0
			if ($c == "<pendent>")	$query_ext = " AND priv_login = 0";

			$query = "SELECT * FROM user WHERE user_group_id = " . $sess->data["user_group_id"] . " $query_ext ORDER BY lastname;";
			# echo $query; exit;

			$db->query($query);
			if ($db->errno)	show_error($db->errno,  $db->error, $HTTP_SERVER_VARS, true); // database connection failed

			$tpl->set_var("ABC", get_alphalist());

			// dynamic block
			$tpl->set_block("adress", "block_adress","block_adress_row");

			if($db->num_rows() > 0)
			{
				while($db->next_record())
				{

					$i++;

					// change background color
					if (bcmod ($i, 2) == 0) $BGRD_CLR = $BGRD_CLR_2; else $BGRD_CLR = $BGRD_CLR_1;

					// check user status
					if($db->field("priv_login") == 0) $BGRD_CLR = $BGRD_CLR_3;

					// set fields
					$tpl->set_var(array(
						"USER_ID"	 	=> $db->field("user_id"),
						"FIRSTNAME" 	=> $db->field("firstname"),
						"LASTNAME" 		=> $db->field("lastname"),
						"STREET" 		=> $db->field("street"),
						"ZIP" 			=> $db->field("zip"),
						"CITY" 			=> $db->field("city"),
						"TELEPHONE" 	=> $db->field("telephone"),
						"FAX" 			=> $db->field("fax"),
						"EMAIL" 			=> $db->field("email"),
						"URL" 			=> $db->field("url"),
						"COMMENT" 		=> $db->field("comment"),
						"BGRD_CLR" 		=> $BGRD_CLR,
						"EDIT"			=> str_replace ("{ID}", $db->field("user_id"), $sEdit)
					));


					//append to blockarea
					$tpl->parse("block_adress_row", "block_adress", true);
				}
			}
			else
			{
				$tpl->set_var("MESSAGE", $RES["0114"]);	// empty search result
			}

			//-------------------------------------------------------------------------
			// parse and print the template
			//-------------------------------------------------------------------------
			$tpl->parse("CONTENT", "adress");		
			$tpl->pparse("OUT", "content");
		}
	}
	exit;
?> 

<?
	//-------------------------------------------------------------------------
	// extra functions
	//-------------------------------------------------------------------------
	function get_alphalist()
	{
		global $RES;
		
		$tag = "<a href='adress.php?c={CHARX}'>{CHAR}</a>";
		$s = "";
		$s .= "<a href='adress.php?c='>". $RES["0126"] ."</a> | ";
		
		for($i=65; $i<=90; $i++)
		{ 
			$tmp = $tag;
			$tmp = str_replace ("{CHAR}", chr($i) , $tmp);
			$s .= str_replace ("{CHARX}", strtolower(chr($i)) , $tmp). " | ";
		}
		$s .= "<a href='adress.php?c=<pendent>'>".$RES["0127"]."</a>";
		return $s;
	}
?>


