<?
	
	require("config.php");
	require("lib/template.class.php"); 
	require("lib/session.class.php");
	require("lib/db_mysql.class.php");
	require("lib/date_time.lib.php");
	
	$GC_PCT	= 100;	// percent chance of garbage collection (remove expired entrys)
  							// 0 for never, 100 for always,
	
	// check session
	$sess = init_session() or show_error(7001, "Cannot init. session!", $HTTP_SERVER_VARS, true);
	if ($sess->name == "") show_error(8000, $RES["0085"], $HTTP_SERVER_VARS, true);	// permission denied
	
	// create template object
	$tpl = new Template(".");
	
	// declare template files
	$tpl->set_file(array(
		"content" 			=> "tpl_content.html",
		"calendar" 			=> "tpl_calendar.html",
		"calendar_entry"	=> "tpl_calendar_entry.html",
		"message"			=> "tpl_message.html"
	));

	// set language fields
	$aTpl = array("content", "calendar", "calendar_entry");	// templates to parse
	while (list($kTpl,$vTpl) = each ($aTpl))
	{
		$arr_undef = $tpl->get_undefined($vTpl);
		while (list($k, $v) = each ($arr_undef))
		{	$tpl->set_var($k,$RES[$v]); }
	}
	
	//-----------------------------------------------------------------------------------
	// Action
	//-----------------------------------------------------------------------------------
	switch($action)
	{
	
		//-----------------------------------------------------------------------------------
		case "update":	// update entry
		{
			// permission checks
			// ...

			// see case "add":
		}
		
		//-----------------------------------------------------------------------------------
		case "add":
		{
			$IMG_ARROW	= "<img src='img/arrow_red.gif' width='11' height='11'>";
			$sError = "";
			
			// check permission
			if($sess->data["priv_groupadmin"] + $sess->data["priv_sysadmin"]  < 1)	$sError .= $IMG_ARROW." ".$RES["0085"]."<br><br>";	// permission denied
			
			// check input
			$ugid = $sess->data["user_group_id"];
			
			if(!isset($ugid) || $ugid < 1)
				$sError .= $IMG_ARROW." ".$RES["0089"]."<br>";	// user group is missing
			
			if (!$d = validate_date($event_date))
				$sError .= $IMG_ARROW." ".$RES["0087"]."<br>";	// invalid date
			//todo: check if date => now();
			
			if ($d["year"] > 2037)
				$sError .= $IMG_ARROW." ".$RES["0107"]."<br>";	// invalid date: max: 2037
				
			if(trim($event_time) != "")
			{
				if (!$t = validate_time($event_time))
					$sError .= $IMG_ARROW." ".$RES["0088"]."<br>";	// invalid time
			}
			
			if(trim($event_title) == "")
				$sError .= $IMG_ARROW." ".$RES["0092"]."<br>";	// title is missing
			
			// are there any errors ?
			if($sError == "")	
			{
				$db = new Database();
				if (!$db->connect()) show_error($db->errno, $db->error, $HTTP_SERVER_VARS, true);
				
				// generate query
				$t["hour"] 		= $t["hour"] 	+ 0;
				$t["minute"] 	= $t["minute"] + 0;
				$t["second"]	= $t["second"] + 0;
				
				// 2002-12-15 23:50:26'
				$tstamp = mktime ($t["hour"], $t["minute"], $t["second"], $d["month"], $d["day"], $d["year"]);
				$dbdate = date ("Y-m-d", $tstamp);
				$dbtime = date ("H:i:s", $tstamp);
				
				// select sql query
				if($action == "update")
					$query = sprintf("UPDATE calendar_entry SET date='%s', time='%s', title='%s', text='%s' WHERE calendar_entry_id = %s AND user_group_id = %s", $dbdate, $dbtime, $event_title, $event_info, $entry_id , $sess->data["user_group_id"]);
				else
					$query = sprintf("INSERT INTO calendar_entry SET user_group_id=%s, date='%s', time='%s', title='%s', text='%s'", $ugid, $dbdate, $dbtime, $event_title, $event_info);
				
				# echo $query; exit;
				
				if (!$db->query($query))		show_error($db->errno, $db->error, $HTTP_SERVER_VARS, true);			
				
				if($action == "add")
					if ($db->affected_rows() < 1) show_error(7061, $RES["0064"], $HTTP_SERVER_VARS, true);
				
				// select title and message
				if($action == "update")
					$msg_txt		= $RES["0105"];		// event has been updated successfully
				else
					$msg_txt		= $RES["0090"];		// event has been added successfully

				$tpl->set_var(array(
					"MSG_TITLE" 	=> $RES["0091"],	// ok
					"MSG_TEXT" 		=>	$msg_txt,
					"BTN1_CLICK" 	=> $RES["0072"],	// window.close()
					"MSG_BUTTON_1" => $RES["0061"]	// refresh parent child
				));
							
				// print template 
				$tpl->pparse("OUT", "message");
				exit;
			}
			else
			{
				// print error messages
				$tpl->set_var(array(
					"MSG_TITLE" 	=> $RES["0093"],
					"MSG_TEXT" 		=>	$sError,
					"BTN1_CLICK" 	=> $RES["0070"],	// history.back()
					"MSG_BUTTON_1" => $RES["0055"]	// back
				));
					
				$tpl->pparse("OUT", "message");
				exit;
			}
			
			break;
		}
			
		//-----------------------------------------------------------------------------------
		case "edit":	// edit entry
		{
			// permission checks
			if ($sess->data["priv_groupadmin"] + $sess->data["priv_sysadmin"]  < 1) show_error(8000, $RES["0085"], $HTTP_SERVER_VARS, true);	// permission denied
			
			// get entry
			$db = new Database();
			if (!$db->connect()) show_error($db->errno, $db->error, $HTTP_SERVER_VARS, true);
			
			$query = sprintf("SELECT *, DATE_FORMAT(date, '%s') AS f_date , TIME_FORMAT(time,'%s') AS f_time FROM calendar_entry WHERE calendar_entry_id = %s AND user_group_id = %s", "%d.%m.%Y", "%H:%i:%s", $entry, $sess->data["user_group_id"]);		
			# echo $query, exit;
			
			if (!$db->query($query))	show_error($db->errno, $db->error, $HTTP_SERVER_VARS, true);			
			if($db->num_rows() < 1)		show_error(8000, $RES["0085"], $HTTP_SERVER_VARS, true);	// permission denied

			// set fields
			$db->next_record();
			
			// format time
			$ft = $db->field("f_time");
			if($ft == "00:00:00") $ft= "";
			
			$tpl->set_var(array(
				"CAL_DATE" 		=> $db->field("f_date"),
				"CAL_TIME" 		=> $ft,
				"CAL_TITLE" 	=> $db->field("title"),
				"CAL_INFO" 		=> $db->field("text"),
				"ENTRY_ID" 		=> $db->field("calendar_entry_id"),
				"ENTRY_TITLE"	=> $RES["0104"],	// edit entry
				"BTN_OK" 		=> $RES["0103"],	// update
				"CAL_ACTION" 	=> "update"
			));

			// parse and print the template
			$tpl->pparse("OUT", "calendar_entry");
				
			break;
		}
		
		//-----------------------------------------------------------------------------------
		case "new":	// add new entry
		{
			// permission checks
			if ($sess->data["priv_groupadmin"] + $sess->data["priv_sysadmin"]  < 1)	show_error(8000, $RES["0085"], $HTTP_SERVER_VARS, true);	// permission denied
			
			// set fields
			$tpl->set_var(array(
				"ENTRY_TITLE"	=> $RES["0094"],	// add entry
				"BTN_OK" 		=> $RES["0102"],	// add
				"CAL_ACTION" 	=> "add"
			));

			// parse and print the template
			$tpl->pparse("OUT", "calendar_entry");
			
			break;
		}
		
		//-----------------------------------------------------------------------------------
		case "delete":
		{
			// check permission
			if($sess->data["priv_groupadmin"] + $sess->data["priv_sysadmin"]  < 1)	show_error(8000, $RES["0085"], $HTTP_SERVER_VARS, true);	// permission denied
			
			// delete entry
			$db = new Database();
			if (!$db->connect()) show_error($db->errno, $db->error, $HTTP_SERVER_VARS, true);
			
			$query = sprintf("DELETE FROM calendar_entry WHERE calendar_entry_id = %s AND user_group_id = %s", $ceid, $sess->data["user_group_id"]);		
			if (!$db->query($query))	show_error($db->errno, $db->error, $HTTP_SERVER_VARS, true);			
			
			// no break, goto default:
		}
		
		//-----------------------------------------------------------------------------------
		// print calendar
		//-----------------------------------------------------------------------------------
		default:
		{

			// permission checks
			// ...
			
			// news edit
			if($sess->data["priv_groupadmin"] + $sess->data["priv_sysadmin"]  >= 1)
			{
				$group = $sess->data["user_group_id"];
				
				$sEdit = "<a href=\"javascript:window_open('calendar.php?action=edit&entry={ID}', 330,280)\"><img src='img/edit.gif' width='16' heigh='16' border='0' alt='" . $RES["0029"]  . "'></a><a href='javascript:confirm_del({ID})'><img src='img/delete.gif' alt='" . $RES["0030"]  . "' width='15' height='15' border='0'></a><b>";
				
				$tpl->set_var(array(
					"SCHEDULE_ADDNEW" => "<a href=\"javascript:window_open('calendar.php?action=new', 330,280)\"><img src='img/new.gif' width='16' height='16' border='0'></a> <a href=\"javascript:window_open('calendar.php?action=new', 330,280)\" class='flat_text'>" . $RES["0027"]
				));
			}

			$db = new Database();	// create new Database object
	
			// connect to mysql server
			if (!$db->connect())		show_error($db->errno,  $db->error, $HTTP_SERVER_VARS, true); // database connection failed

			// evaluate the chance for garbage collection
			if (rand(0, 99) < $GC_PCT)
			{
				// remove expired entrys
				$sql = "DELETE FROM calendar_entry WHERE date < CURDATE() OR date = NULL OR date = '';";
				if (!$db->query($sql))	show_error($db->errno, $db->error, $HTTP_SERVER_VARS, false);
			}

			// execute sql query
			$sql = 	"SELECT *, DATE_FORMAT(date, '%d.%m.%Y') AS f_date, TIME_FORMAT(time,'%H:%i:%s') AS f_time FROM calendar_entry WHERE user_group_id = " . $sess->data["user_group_id"]." ORDER BY date;";
			# echo $sql; exit;

			if (!$db->query($sql))	show_error($db->errno, $db->error, $HTTP_SERVER_VARS, true);

			// table background colors
			$CAL_BGRD_CLR_1 = "#FFFF99";	// yellow
			$CAL_BGRD_CLR_2 = "#FFFFCC";	// dark yellow
			$CAL_BGRD_CLR_3 = "#FFC4C4";	// red (for today)

			// dynamic block
			$tpl->set_block("calendar", "block_calendar","block_calendar_row");

			while($db->next_record())
			{
				$i++;

				// change background color
				if (bcmod ($i, 2) == 0) $CAL_BGRD_CLR = $CAL_BGRD_CLR_2; else $CAL_BGRD_CLR = $CAL_BGRD_CLR_1;

				// select events of today with red background
				if($db->field("f_date") == date("d.m.Y")) $CAL_BGRD_CLR = $CAL_BGRD_CLR_3;

				$ft = $db->field("f_time");
				if(trim($ft) != "00:00:00") $ft = " - <i>$ft</i>"; else $ft = "";

				$id = $db->field("calendar_entry_id");

				// set fields
				$tpl->set_var(array(
					"CAL_BGRD_CLR" => $CAL_BGRD_CLR,
					"CAL_DATE" 		=> "<b>" . $db->field("f_date") . "</b>",
					"CAL_TIME" 		=> $ft,
					"CAL_TITLE" 	=> $db->field("title"),
					"CAL_TEXT" 		=> str_replace ("\n", "<br>", $db->field("text")),
					"SCHEDULE_EDIT"=> str_replace ("{ID}", "$id", $sEdit)
				));

				//append to blockarea
				$tpl->parse("block_calendar_row", "block_calendar", true);
			}

			//-------------------------------------------------------------------------
			// parse and print the template
			//-------------------------------------------------------------------------
			$tpl->parse("CONTENT", "calendar");
			$tpl->pparse("OUT", "content");
		}
	}

?> 

