<?
// Database Class to query or execute on a database
// Version 1.1.1

class Database
{
	// public: database connection parameters
	var $Database  = false;  // default database
	var $Host      = false;  // default host (<host>[:<port>])
	var $User      = false;  // default user
	var $Password  = false;  // default password

	// base configuration
	var $AutoFree  = false;  // automatic mysql_free_result()
	var $Debug     = false;  // give debugging messages

	// public: result array and current row number
	var $Record    = false;
	var $Row       = false;

	// public: error management
	var $EvalOnError 	= "\$this->haltmsg(\$this->ErrorMsg);";
	var $EMailOnError	= "daniel@source-center.de";	//Webmaster E-Mail
	var $TitleOnError	= "fahrschule-linsin.de";		//Hompepage title
	var $HaltOnError 	= "yes"; 		// "yes"    (halt with message)
									 			// "no"     (ignore errors quietly)
									 			// "report" (ignore errror, but spit a warning -> MailOnError)
									 		
	var $ErrorMsg  = false;
	var $ErrorNo   = false;
	var $ErrorDB   = false;

	// private: link and query handles
	var $LinkID   = false;
	var $QueryID  = false;
	
	//---------------------------------------------------------------------------------
	// constructor
	function Database($Database = false, $Host = false, $User = false, $Password = false)
	{
		$this->Database = $Database;
		$this->Host     = $Host;
		$this->User     = $User;
		$this->Password = $Password;
	}
	//---------------------------------------------------------------------------------
	// public: copy database handle
	function copy()
	{
		$ndb = new Database($this->Database, $this->Host, $this->User, $this->Password);

		$ndb->AutoFree    = $this->AutoFree;
		$ndb->Debug       = $this->Debug;
		$ndb->EvalOnError = $this->EvalOnError;
		$ndb->HaltOnError = $this->HaltOnError;
		return $ndb;
	}
	//---------------------------------------------------------------------------------
	// public: connection management
	function connect($Database = false, $Host = false, $User = false, $Password = false)
	{
		// save new connection parameters
		if(!$Database)  $Database = $this->Database;
		if(!$Host)      $Host     = $this->Host ? $this->Host : "localhost";
		if(!$User)      $User     = $this->User;
		if(!$Password)  $Password = $this->Password;

		// check available parameters
		if(!$Database)
		{
		$this->halt("Es wurde keine Datenbank fr den Verbindungsaufbau angegeben.");
		return false;
		}

		// establish new connection only if not allready done
		if(!$this->LinkID)
		{
			$this->LinkID = mysql_pconnect($Host, $User, $Password);
			$this->ErrorNo  = mysql_errno();
			$this->ErrorDB  = mysql_error();
			
			if(!$this->LinkID)
			{
			$pwstring = ereg_replace(".","*",$Password);
			  //$this->halt("Verbindungsaufbau 'pconnect($Host, $User, $pwstring)' zur Datenbank misslungen.");
			  $this->halt("Verbindungsaufbau 'pconnect($Host,...)' zur Datenbank misslungen.");
			  return false;
			}

			// select database
			if(!@mysql_select_db($Database, $this->LinkID))
			{
			  $this->halt("Die Datenbank '".$this->Database."' kann nicht genutzt werden.");
			  return false;
			}
		}

		return $this->LinkID;
	}
	//---------------------------------------------------------------------------------
	// public: discard the query result
	function free()
	{
		@mysql_free_result($this->QueryID);
		$this->QueryID = false;
	}
	//---------------------------------------------------------------------------------
	// public: perform a sql statement
	function query($SQL)
	{
		// No empty queries, please, since PHP4 chokes on them.
		if(!$SQL) return false; // No action needed.
		// try to connect
		if(!$this->connect()) return false; // already complained in connect()
		// new query, discard previous result.
		if($this->QueryID) $this->free();
		if ($this->Debug) printf("\n<br>Debug: query = '%s'!", $SQL);

		// execute the query
		$this->QueryID = @mysql_query($SQL, $this->LinkID);
		$this->Row      = false;
		$this->ErrorNo  = mysql_errno();
		$this->ErrorDB  = mysql_error();
		// check if everything goes right
		if(!$this->QueryID) $this->halt("Invalid SQL: ".$SQL);
		// will return nothing if it fails
		return $this->QueryID;
	}
	//---------------------------------------------------------------------------------
	// public: perform a query and read the first record
	function queryRow($Query_String)
	{
		$this->query($Query_String);
		$this->nextRecord();
		return $this->QueryID;
	}
	//---------------------------------------------------------------------------------
	// public: walk result set
	function nextRecord()
	{
		if(!$this->QueryID)
		{
			$this->halt("nextRecord wurde ohne ein aktives Abfrageergebnis aufgerufen.");
			return false;
		}

		// switch record
		$this->Record   = @mysql_fetch_array($this->QueryID);
		$this->Row     += 1;
		$this->ErrorNo  = mysql_errno();
		$this->ErrorDB  = mysql_error();

		$stat = is_array($this->Record);
		if(!$stat && $this->AutoFree) $this->free();

		return $stat;
	}
	//---------------------------------------------------------------------------------
	// public: position in result set
	function seek($pos=false)
	{
		$status = @mysql_data_seek($this->QueryID, $pos);
		if($status) $this->Row = $pos;
		else
		{
			$this->halt("seek($pos) failed: Es gibt nur ".$this->numRows()." Datenstze.");

			// jump to the last record and return false
			@mysql_data_seek($this->QueryID, $this->numRows());
			$this->Row = $this->numRows;
			return false;
		}
		return 1;
	}
	//---------------------------------------------------------------------------------
	// public: table locking
	function lock($table, $mode="write")
	{
		$this->connect();

		$query = "lock tables ";
		if (is_array($table))
		{
			while (list($key,$value) = each($table))
			{
				if ($key=="read" && $key!=0)
					$query.="$value read, ";
			  	else
					$query.="$value $mode, ";
			}
			$query = substr($query, 0, -2);
		}
		else
		{
			$query .= "$table $mode";
		}
		
		$res = @mysql_query($query, $this->LinkID);
		if (!$res)
		{
			$this->halt("lock($table, $mode) failed.");
			return false;
		}
		return $res;
	}
	//---------------------------------------------------------------------------------
	function unlock()
	{
		$this->connect();

		$res = @mysql_query("unlock tables");
		if (!$res)
		{
			$this->halt("unlock() failed.");
			return false;
		}
		return $res;
	}
	//---------------------------------------------------------------------------------
	//public: Liefert die Kennung einer vorherigen INSERT-Operation
	function insertID ()
	{
		return @mysql_insert_id ($this->LinkID);
	}
	//---------------------------------------------------------------------------------
	// public: evaluate the result (size, width)
	function affectedRows()
	{
		return @mysql_affected_rows($this->LinkID);
	}
	//---------------------------------------------------------------------------------
	function numRows()
	{
		return @mysql_num_rows($this->QueryID);
	}
	//---------------------------------------------------------------------------------
	function numFields()
	{
		return @mysql_num_fields($this->QueryID);
	}
	//---------------------------------------------------------------------------------
	// public: shorthand notation
	function field($Name)
	{
		return $this->Record[$Name];
	}
	//---------------------------------------------------------------------------------
	// public:  Liefert den Namen eines Feldes in einem Anfrageergebnis 
	function fieldName($offset)
	{
		return @mysql_field_name ($this->QueryID, $offset);
	}
	//---------------------------------------------------------------------------------
	// public:   Liefert den Namen der Tabelle, die das genannte Feld enthlt
	function fieldTable($offset)
	{
		return @mysql_field_table ($this->QueryID, $offset);
	}
	//---------------------------------------------------------------------------------
	// public:   Liefert den Typ eines Feldes in einem Anfrageergebnis 
	function fieldType($offset)
	{
		return @mysql_field_type ($this->QueryID, $offset);
	}
	//---------------------------------------------------------------------------------
	// public:   Liefert den Typ eines Feldes in einem Anfrageergebnis 
	function fieldFlags($offset)
	{
		return @mysql_field_flags ($this->QueryID, $offset);
	}
	//---------------------------------------------------------------------------------
	// public:   Liefert die Lnge eines Feldes 
	function fieldLen($offset)
	{
		return @mysql_field_len ($this->QueryID, $offset);
	}
	//---------------------------------------------------------------------------------
	// public:   Listet die Felder einer Tabelle auf
	function listFields($dbname, $tablename)
	{
		return @mysql_list_fields ($dbname, $tablename, $this->LinkID);
	}
	//---------------------------------------------------------------------------------
	// public:   Liefert eine Liste der verfgbaren Datenbanken auf dem Server 
	function listDBs()
	{
		return @mysql_list_dbs ($this->LinkID);
	}
	//---------------------------------------------------------------------------------
	// public:   Liefert eine Liste der Tabellen in einer Datenbank
	function listTables($dbname)
	{
		return @mysql_list_tables ($dbname, $this->LinkID);
	}
	//---------------------------------------------------------------------------------
	// public: Liefert den Namen einer Tabelle
	function tableName ($offset)
	{
		return @mysql_tablename ($this->QueryID,$offset);
	}
	//---------------------------------------------------------------------------------
	// public: Erzeugt eine Datenbank
	//	Rckgabewert: true im Erfolgsfall, false ein Fehlerfall. 
	function createDB ($dbname)
	{
		return @mysql_create_db ($dbname,$this->LinkID);
	}
	//---------------------------------------------------------------------------------
	// public: Entfernt eine Datenbank
	//	Rckgabewert: true im Erfolgsfall, false ein Fehlerfall. 
	function dropDB ($dbname)
	{
		return @mysql_drop_db ($dbname,$this->LinkID);
	}
	
	// ToDo
	// create a CSV file from the data set returned from a $sql statement 
	// requires that the $filename be writeable by the webserver  
	/*	
	function csvdatadump($filename, $sql, $db) {    
	 $pointer = fopen($filename,"w");
		 $dataset = $db->query($sql);

	 // open the file and write the dataset       
	 fwrite($pointer,implode(",",$dataset[0])."\r\n");
		for ($i = 1; $i < count($dataset); $i++) {
			 $dataset[$i][5] = date("d/m/Y",$dataset[$i][5]);
		  fwrite($pointer,implode(",",$dataset[$i])."\r\n");
		}
	 fclose($pointer);

	 // send the file to the browser       
	 $pointer = fopen($filename,"r");
	 echo header("content-type: application/csv");
	 echo header("content-disposition: inline; filename=".basename($filename));
	 echo header("content-length: ".filesize($filename));
	 echo fread($pointer,4194304);
	 fclose($pointer);

	 // clean out the file
	 $pointer = fopen($filename,"w");
	 fclose($pointer);
	 exit;
	}
	*/
	
	//---------------------------------------------------------------------------------
	// private: error handling
	function halt($msg)
	{
		$this->ErrorMsg = $msg;
		$this->ErrorNo    = @mysql_errno($this->LinkID);
		$this->ErrorDB  = @mysql_error($this->LinkID);
		if($this->HaltOnError == "no")     return;
		eval($this->EvalOnError);
		if($this->HaltOnError != "report") die("Session halted.");
	}
	//---------------------------------------------------------------------------------
	function haltmsg($msg)
	{
		print "</td></tr></table>"; // maybe a table cell has been opened
		$message  = "<p><b>Database Error:</b> ".$this->ErrorMsg;
		$message .= "<br><b>MySQL Error</b>: (".$this->ErrorNo.") ";
		$message .= $this->ErrorDB."<p>The Webmaster has been informed!\n";
		print $message;

		$message  = "\nDatabase Error: ".$this->ErrorMsg;
		$message .= "\nMySQL Error:    (".$this->ErrorNo.") ".$this->ErrorDB;
		
		/* original
		@mail("webmaster@".$GLOBALS["HTTP_HOST"],
		  "Website Error: database problem",
		  $message,
		  "From: database.php@".$GLOBALS["HTTP_HOST"]."\nX-Mailer: PHP/" . phpversion());
		*/
		
		@mail($this->EMailOnError,
				  "Website Error: database problem (" . $this->TitleOnError .")",
				  $message,
		  "From: " . $this->EMailOnError ."\nX-Mailer: PHP/" . phpversion());
		  
	}

}


//---------------------------------------------------------------------------------
// check the database class
function testClass_database()
{
  print "<p><b>Test: Class database</b>";

  $ok   = 0;
  $fail = 0;
  
  	/*
    print "<br>the same, parameters given via connect method - ";
    $db = new Database;
    if($db->connect("test","localhost","root",""))
         { $ok++;   print "OK"; }
    else { $fail++; print "failed"; }
	*/

  print "<br>connecting to test database on localhost (user test) - ";
  $db = new Database("test","localhost:3306","root","");
  
  //$db->Debug = true;
  
  if($db->connect())
  {
		$ok++;   print "OK";

		print "<br>create a table mydbtest - ";
		$sql  = "CREATE TABLE mydbtest (rs_id INT (11) DEFAULT '0' NOT NULL AUTO_INCREMENT, name VARCHAR (20), value VARCHAR (30), PRIMARY KEY(rs_id), UNIQUE(rs_id), INDEX(rs_id))";
		
		if($db->query($sql))
			 { $ok++;   print "OK"; }
		else { $fail++; print "failed"; }

		print "<br>check for the number of entries - ";
		$db->query("select * from mydbtest");
		if(!$db->numRows())
			 { $ok++;   print "OK"; }
		else { $fail++; print "failed"; }

		
		print "<br>insert value into table - ";
		if($db->query("INSERT INTO mydbtest (name,value) VALUES ('system.version.db','0.1')"))
		{
			if($db->insertID()>0)
			{
				$ok++;   print "OK";
				echo "Neue ID: " . $db->insertID();
			}
			else
			{
				$fail++; print "failed";
			}
		}
		else { $fail++; print "failed"; }


		//select
		print "<br>check for the number of entries - ";
		if($db->query("select * from mydbtest"))
		{
			$ok++;   print "OK";
			print "<br>output table >>> ";
			
			$x=0;
			while($db->nextRecord())
			{
				$x++;
				echo "<hr> $x: " . $db->Field("name") . "<hr><br>";
			}
		}
		else
		{
			$fail++; print "failed";
		}
		
		
		print "<br>drop the mydbtest table - ";
		if($db->query("drop table mydbtest"))
			 { $ok++;   print "OK"; }
		else { $fail++; print "failed"; }
       	
  }
  else
  {
  	$fail++; print "failed";
  }
	
	print "<br><b>Finished: ";
	
	if(!$fail)
	{
		print "all tests successfully";
	}
	else
	{
		print "$fail from ".($ok+$fail)." tests failed";
		print "</b>";    	 
	}
		
}


//testClass_database();
