<?php
// ----------------------------------------------------------------------------------
//
// generic ini-file driven FTP class 
//
// (c) 07.05.2001 M.Chilla
// http://sourceforge.net/snippet/detail.php?type=package&id=100092
// ---------------------------------------------------------------------------------
//
// methods :
//		.connect 	--> establishes FTP connection and authenticates
//		.lastmodtime 	--> return last_mod_date of a specific file
//		.changedir 	--> changes directory
//		.getdir 	--> returns actual directory (pwd)
//		.get_file_list 	--> returns directory-list as array
//		.get_file 	--> downloads a specific file
//		.mode 		--> changes modes between active/passive
//		.ftp_bye 	--> logs out of the ftp server
// 
// ----------------------------------------------------------------------------------

// ------------------------------------------------------------
//
// example config file for FTP class
//
// $mymode declares download mode
// 	FTP_ASCII 	= ASCII Mode
//	FTP_BINARY 	= BINARY Mode
//
// $delete (0/1) 0 	= just download file
//		 1 	= after download delete this file from FTP server
//
// $localdir		= local destination directory
// $host		= target FTP server
// $anonymous (0/1) 0	= normal login mode (username/password)
//		    1	= if set, a connection as ANONYOMOUS will be established
// $user / $password	= (bogus if $anonymous = 1) authentication params
// ------------------------------------------------------------

// ------------------------------------------------------------
// Configuration
// ------------------------------------------------------------
$mymode			= FTP_ASCII;
$delete			= 0;
$local_dir	 	= "/my_local_download_directory";
$host 			= "ftp.yahoo.de";
$remote_dir	 	= ".";
$anonymous		= 0;
$user 			= "myusername";
// take care !!! 
// password has to be "escaped" 
// if special characters are in it !!!
$password 		= "mypassword";

// ------------------------------------------------------------

class myftp {

	var $connector;
	var $getback;
	
	function connect($ftp_server, $uname, $passwd){
	// Baut grundlegende FTP Connection auf
		$this->connector = @ftp_connect($ftp_server);
		$this->login_result = @ftp_login($this->connector, "$uname", "$passwd");
		if ((!$this->connector) || (!$this->login_result)) 
		{ 
		        echo "FTP connection has failed! \n";
		        echo "Attempted to connect to $ftp_server for user $uname \n"; 
		        die; 
		    } else {
		        echo "Connected to $ftp_server, for user $uname \n";
	    	}
	}

	function lastmodtime($value){
		$getback = ftp_mdtm ($this->connector,$value);
		return $getback;
	}

	function changedir($targetdir){
		$getback = ftp_chdir($this->connector, $targetdir);
		return $getback;
	}
	function getdir(){
	// Liefert Directory Namen zurck (pwd)
		$getback = ftp_pwd($this->connector);
		return $getback;
	}
	
	function get_file_list($directory){
	// Liefert Array mit Directory zurck
		$getback = ftp_nlist($this->connector, $directory);
		return $getback;
	}
	
	function get_file($file_to_get, $mode, $mode2){

		$realfile = basename($file_to_get);
		$filename = $realfile;

		// Prfen ob wir einen Ordner haben
		$checkdir = @$this->changedir($realfile);
		if ($checkdir == TRUE){
			ftp_cdup($this->connector);
			echo "\n[DIR] $realfile";
		}else{
			echo "..... ". $realfile ."\n";
			$getback = ftp_get($this->connector, $filename, $realfile, $mode);
			if ($mode2){
				$delstatus = ftp_delete($this->connector, $file_to_get);
				if ($delstatus == TRUE){
					echo "File $realfile on $host deleted \n";
				}
			}
		}
		return $getback;
	}
	
	function mode($pasvmode){
		$result = ftp_pasv($this->connector, $pasvmode);
	}
	
	function ftp_bye(){
		ftp_quit($this->connector); 
		return $getback;
	}
}

?>

<?
// ------------------------------------------------------------
// example
// ------------------------------------------------------------
/*
flush();

$ftp_ini_datei 		= $argv[1];

require ('./ftp_class.php');
require ($ftp_ini_datei);

echo "\nCronjob started : ";
echo date("d.m.Y  - H:i:s");
echo "\n";

$newftp 		= new myftp;

if(!$anonymous){
	$result 	= $newftp->connect($host, $user, $password);
}else{
	$result		= $newftp->connect($host, "anonymous", "mymail@somewhere.com");
}

if (!$result){
	$mydir 		= $newftp->changedir($remote_dir);
	$mydir		= $newftp->getdir();
	$merkold_dir	= getcwd();
	chdir($local_dir);
	$mylist 	= Array(); 
	$mylist 	= $newftp->get_file_list($mydir); 


	
	for ($i=0; $i < sizeof($mylist); $i++)
	{
		$result = $newftp->get_file($mylist[$i], $mymode, $delete);
	}

	$result 	= $newftp->ftp_bye();

}else{

	echo "----------------------------------\n";
	echo "no connection established :(      \n";
	echo "----------------------------------\n";

}

echo "\n\nCronjob stopped : ";
echo date("d.m.Y - H:i:s");
echo "\n";
*/
?>
