<?php

/*

Main Include File

	This will always be a work in progress.

	This code is free, with the exception that if you use it for
	any of your own projects, you must include my email address

	scott@furt.com


Some error handling and global variables that i
like to re-use in my other scripts...


*/


// $Svar is the array for my global variables, so i only need to declare
// global $Svar in each of my functions, rather than declare oodles
// of actual variables.
//
// i try to keep all the truly global information
// in this one assoc. array.

  $Svar = array();

  // error message holder (used by the error functions
  //   to store current error messages)
  $Svar["ERROR"]		= '';

  // database flags
  // set by: db.php
  $Svar["db_connected"]		= 0;	// are we connected already?
  $Svar["db_linkid"]			= 0;	// current linkid of our connection

  // database connect information
  // used by: db.php
  /*
  $Svar["db_host"]	= 'localhost';
  $Svar["db_user"]	= 'root';
  $Svar["db_pw"]	= 'root';
  $Svar["db_db"]	= 'eschool';
	*/
	$Svar["db_host"]	= $cfg["db.host"];
	$Svar["db_user"]	= $cfg["db.username"];
	$Svar["db_pw"]		= $cfg["db.password"];
	$Svar["db_db"]		= $cfg["db.database"];

/*
Misc error handler.
sets the global 'ERROR' key to the error text and returns "0"
useful to escape out of subroutines and describe an error at the same time.

  if (error) {
	return error("This is my error.");
  }
*/
function error($text) {
  global $Svar;
  $Svar['ERROR'] = $text ."\n";
  return 0;
}


/*
Adds $text onto the end of the current error text,
good for bubbling up error text out of a chain of functions

if (error) {
	return errorcat("Don't overwrite the original error text.  Just append this");
  }
*/

function errorcat($text) {
  global $Svar;
  $Svar['ERROR'] .= $text ."\n";
  return 0;
}

/*
Database error call, it will append some database specific
values to the error message (like host/user/mysql_error)

  if (database error) {
	return dberror("This is my error.");
  }

*/
function dberror($text) {
  global $Svar;
  $Svar['ERROR'] =
  	"<B>Database Error:</B>
  	$text
  	<FONT SIZE=-2>
  	Host:(". $Svar['db_host'] .") - User:(". $Svar['db_user'] .")
  	Mysql Error: ". mysql_error() ."\n\n";
  return 0;
}



/*
Output error and stop processing

Prints out a little red box with the error text inside, alerting
the user to the fact that the program has been torn asunder.

Appends the current value of $Svar['ERROR'] to $text

  if (fatal error) {
  	death("Fatal Error occured!  Oh no!");
  }

*/
function death($text='') {
  global $Svar;

  if ($text) {
	$text .= "\n\n";
  }

	// output some raw HTML
	?>
	<HTML><HEAD><TITLE>Application Error</TITLE></HEAD>
	<BODY BGCOLOR="WHITE" TEXT="RED" LINK="BLUE" VLINK="BLUE" ALINK="BLUE">

	<TABLE WIDTH="600" BORDER="0" CELLSPACING="0" CELLPADDING="2"><TR><TD BGCOLOR="#FF0000">
	<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="5"><TR><TD BGCOLOR="WHITE">

	<FONT FACE="Verdana,Arial" SIZE=-1 COLOR="BLACK">

	<B><FONT SIZE=+1 COLOR=RED>There was an Error!</FONT><!-- error text follows--></B>
	<BR><BR>
	<?php

  // add the current text onto the end of the global error var
  $Svar['ERROR'] = $text . $Svar['ERROR'];

  //regexp, change all linebreaks to HTML-ized linebraks (<BR>)
  print ereg_replace("\n", "<BR>\n", $Svar['ERROR']);


 	?>
 	</TD></TR></TABLE>
	</TD></TR></TABLE>
 	<?

  die(); exit();
}



?>
