<?php

/*

Database handler functions

	This will always be a work in progress.

	This code is free, with the exception that if you use it for
	any of your own projects, you must include my email address

	scott@furt.com

Provides an interface to the mysql database

reqires:
  main.php	- for error handling and $Svar[]  (all error*() functions)


Variables needed: (from main.php)
  ** You must properly set the following variables for a call to db_connect() to work sucesfully
	$Svar['db_host'] = 'host';
	$Svar['db_user'] = 'user';
	$Svar['db_pw']   = 'password';
	$Svar['db_db']   = 'database';

Variables set:
	$Svar['db_linkid']    = #;
	$Svar['db_connected'] = 1|0;


*/


/*
Connects to the database with db_* information in $Svar

	returns 1=connected
		0=error


if (!db_connect()) {
	die("Cannot connect!");
}
else {
	die("Connected!");
}

*/
function db_connect() {
  global $Svar;	// global array for database related values

  //in case no Svar is present!
  if (! is_array($Svar) ) {
  	return dberror("Svar global array is not found! I need values from there to properly connect to the database!");
  }

  // check to see if we're already connected,
  // if so, just return without trying to connect again
  if ( db_isconnected() ) { return 1; }

  // connect to MySQL (persistant if possible)
  $Svar["db_linkid"] = @mysql_pconnect($Svar["db_host"], $Svar["db_user"], $Svar["db_pw"]);
  if (!$Svar["db_linkid"]) {
  	return dberror("Problem with mysql_pconnect");
  }

  // select our database
  $result = @mysql_select_db( $Svar["db_db"], $Svar["db_linkid"] );
  if (!$result) {
  	return dberror("Problem with mysql_select_db(". $Svar['db_db'] .")");
  }

  // since the connection just happened, set the flag
  $Svar["db_connected"]++;

  return 1;
}



/*
Executes a query and returns the result *as* a result.
  No actual database data is returned.

  	$result = db_query('SELECT * FROM table LIMIT 1');
  	if ($result) {
  		print "Selected OK";
		$row = db_fetch_hash($result);
  	}

  To fetch all the results, use db_fetch_* functions

*/
function db_query($sql) {
  global $Svar;

  if (! db_isconnected() ) { return error("You are not connected to the database!"); }

  $result = @mysql_query($sql, $Svar["db_linkid"]);
  if (!$result) {
  	return dberror("Could not execute SQL query!\nSQL: ". $sql );
  }

  return $result;
}



/*
Executes a query and returns the result as "row" format

$row->field = "value";

**Only returns one row
  For multiple rows, use:
	$result = db_query(...)
	while (...) {
		$row = db_fetch_row($result)
	}

*/
function db_query_row($sql) {
  global $Svar;

  if (! db_isconnected() ) { return error("You are not connected to the database!"); }

  $result = @mysql_query($sql, $Svar["db_linkid"]);
  if (!$result) {
  	return dberror("Could not execute SQL query!\nSQL: $sql");
  }

  //$numrows = @mysql_numrows($result);
  //if ($numrows == 0) {
  //	return 0;
  //}

  $row = @mysql_fetch_row($result);
  if (!$row) {
  	return dberror("Could not fetch results (row format)!");
  }

  mysql_free_result($result);

  return $row;
}


/*
Executes a query and returns the result as a PHP array

$row[0] = "value";

**Only returns one row
  For multiple rows, use:
	$result = db_query(...)
	while (...) {
		$row = db_fetch_array($result)
	}

*/
function db_query_array($sql) {
  global $Svar;

  if (! db_isconnected() ) { return error("You are not connected to the database!"); }

  $result = @mysql_query($sql, $Svar["db_linkid"]);
  if (!$result) {
  	return dberror("Could not execute SQL query!\nSQL: $sql");
  }

  //dont return error on empty set - sql might be valid, yet no results returned!
  //$numrows = @mysql_numrows($result);
  //if ($numrows == 0) {
  //	return 0;
  //}

  $row = @mysql_fetch_array($result);
  if (!$row) {
  	return dberror("Could not fetch results (array format)!\nSQL: $sql");
  }

  mysql_free_result($result);

  return $row;
}



/*
Executes a query and returns the result as an assoc. array (or 'hash')

$row['field'] = "value";

**Only returns one row
  For multiple rows, use:
	$result = db_query(...)
	while (...) {
		$row = db_fetch_hash($result)
	}

*/
function db_query_hash($sql) {
  global $Svar;

  if (! db_isconnected() ) { return error("You are not connected to the database!"); }

  $result = @mysql_query($sql, $Svar["db_linkid"]);
  if (!$result) {
  	return dberror("Could not execute SQL query!\nSQL: $sql");
  }

  //dont return error on empty set - sql might be valid, yet no results returned!
  //$numrows = @mysql_numrows($result);
  //if ($numrows == 0) {
  //	return 0;
  //}

  $row = @mysql_fetch_array($result, MYSQL_ASSOC);
  if (!$row) {
  	return dberror("Could not fetch results (hash format)!");
  }

  mysql_free_result($result);

  return $row;
}



/*
Given a valid query "result" string, it'll fetch the
next row of results in array format, and return that row.
*/
function db_fetch_array($result) {
  global $Svar;

  $row = @mysql_fetch_array($result);
  if (!$row) {
  	return dberror("Could not fetch results (hash format)!");
  }

  return $row;
}

/*
Given a valid query "result" string, it'll fetch the
next row of results in hash format, and return that row.
*/
function db_fetch_hash($result) {
  global $Svar;

  $row = @mysql_fetch_array($result, MYSQL_ASSOC);
  if (!$row) {
  	return dberror("Could not fetch results (hash format)!");
  }

  return $row;
}




/*
Checks to make sure database is connected.

	db_connect() sets $Svar['db_linkid'] to the connection's link id
		and sets $Svar['db_connected'] to "1" when it connects
*/
function db_isconnected() {
  global $Svar;

  if ( ($Svar["db_connected"] == 1) && (isset($Svar["db_linkid"])) ) {
  	// Yes, the database has been connected to already
  	return 1;
  }

  // No, you need to connect
  return 0;
}









/*
Quote a value to make it appropriate for inclusion in an SQL string
escape all single quotes into double quotes (which is valid SQL syntax)
*/
function db_quote($value) {
  return "'". preg_replace("/'/", "''", $value) ."'";
}





?>
